//------------------// //------------------// //------------------// //------------------// //------------------//
void SHAPES() {
  diamond();          delay(100);
  diamondFill();      delay(100);
  diamondTopBottom(); delay(500);
  boxCWo2i();         delay(100);
  boxCWi2o();         delay(500);
  boxCCWo2i();        delay(100);
  boxCCWi2o();        delay(500);
  boxesO2I2O();       delay(100);
  boxesI2O2I();       delay(500);
  circleFill();       delay(500);
  blockLRTBM12();     delay(500);
  blockMarchLRTBM12(); delay(500);
  blockLRM1M2();      delay(500);
  blockTBLRM12();     delay(500);
  blockMarchTBLRM12(); delay(500);
  blockTBM1M2();      delay(500);
  rowWaveT2B2T();     delay(500);
  boxes4O2I2O();      delay(500);
  diamonds6();        delay(500);
  tictactoe();        delay(500);
  gridSpots();        delay(500);
  //xCross();         delay(500);
}

//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void diamond() {                             // Form a diamond shape in each matrix.
  matrix1.setBrightness(255);                // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 24);
  blankMatrices();     matrix1.show();     matrix2.show();
  int diamond[12] = {3, 10, 12, 17, 21, 24, 30, 33, 37, 42, 44, 51};
  for (i = 0; i < 12; i++) {
    matrix1.drawPixel(diamond[i], 0, aC[rndClr1]);
    matrix2.drawPixel(diamond[i], 0, aC[rndClr1]);
    matrix1.show();     matrix2.show();
    delay(50);
  }
  for (i = 0; i < 12; i++) {
    matrix1.drawPixel(diamond[i], 0, BLACK);
    matrix2.drawPixel(diamond[i], 0, BLACK);
    matrix1.show();    matrix2.show();
    delay(50);
  }
  matrix1.setBrightness(100);
  matrix2.setBrightness(100);
  delay(normal);
}
//------------------//
void diamondFill() {                             // Fill a diamond shape in each matrix.
  matrix1.setBrightness(100);                    // 0-255. 127 = half-brightness.
  matrix2.setBrightness(100);
  int rndClr1  = random(0, 24);
  int diamond[25] = {3,  10, 11, 12,  17, 18, 19, 20, 21,  24, 25, 26, 27, 28, 29, 30,  33, 34, 35, 36, 37,  42, 43, 44,  51};
  for (i = 0; i < 25; i++) {
    matrix1.drawPixel(diamond[i], 0, aC[rndClr1]);
    matrix2.drawPixel(diamond[i], 0, aC[rndClr1]);
    matrix1.show();     matrix2.show();
    delay(25);
  }
  for (i = 0; i < 25; i++) {
    matrix1.drawPixel(diamond[i], 0, BLACK);
    matrix2.drawPixel(diamond[i], 0, BLACK);
    matrix1.show();    matrix2.show();
    delay(25);
  }
}
//------------------//
void diamondTopBottom() {                        // Fill the top half of a diamond, followed by the bottom half of a diamond in each matrix.
  matrix1.setBrightness(100);                    // 0-255. 127 = half-brightness.
  matrix2.setBrightness(100);
  int rndClr1  = random(0, 24);

  int triTop[16] = {3,  10, 11, 12,  17, 18, 19, 20, 21,  24, 25, 26, 27, 28, 29, 30};
  for (i = 0; i < 16; i++) {
    matrix1.drawPixel(triTop[i], 0, aC[rndClr1]);
    matrix2.drawPixel(triTop[i], 0, aC[rndClr1]);
    matrix1.show();     matrix2.show();
  }
  delay(150);

  for (i = 0; i < 16; i++) {
    matrix1.drawPixel(triTop[i], 0, BLACK);
    matrix2.drawPixel(triTop[i], 0, BLACK);
    matrix1.show();    matrix2.show();
  }

  int triBottom[16] = {24, 25, 26, 27, 28, 29, 30,  33, 34, 35, 36, 37,  42, 43, 44,  51};
  for (i = 0; i < 16; i++) {
    matrix1.drawPixel(triBottom[i], 0, aC[rndClr1]);
    matrix2.drawPixel(triBottom[i], 0, aC[rndClr1]);
    matrix1.show();     matrix2.show();
  }
  delay(150);

  for
  (i = 0; i < 16; i++) {
    matrix1.drawPixel(triBottom[i], 0, BLACK);
    matrix2.drawPixel(triBottom[i], 0, BLACK);
    matrix1.show();    matrix2.show();
    //delay(25);
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void boxCWo2i() {                                       // Display all four boxes, ClockWise, outer-to-inner, on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(255);                           // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int CWo2i[64] = {0, 1, 2, 3, 4, 5, 6, 7, 15, 23, 31, 39, 47, 55, 63, 62, 61, 60, 59, 58, 57, 56, 48, 40, 32, 24, 16, 8, 9, 10, 11, 12, 13,
                   14, 22, 30, 38, 46, 54, 53, 52, 51, 50, 49, 41, 33, 25, 17, 18, 19, 20, 21, 29, 37, 45, 44, 43, 42, 34, 26, 27, 28, 36, 35
                  };
  for (i = 0; i < 64 ; i++) {
    matrix1.drawPixel(CWo2i[i], 0, aC[rndClr1]);
    matrix2.drawPixel(CWo2i[i], 0, aC[rndClr1]);
    matrix1.show();   matrix2.show(); delay(veryFast);
    matrix1.drawPixel(CWo2i[i], 0, BLACK);
    matrix2.drawPixel(CWo2i[i], 0, BLACK);
    matrix1.show();   matrix2.show();
  }
}
//------------------//
void boxCWi2o() {                                       // Display all four boxes, clockwise, inner-to-outer, on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(255);                           // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int CWi2o[64] =  {0, 8, 16, 24, 32, 40, 48, 56, 57, 58, 59, 60, 61, 62, 63, 55, 47, 39, 31, 23, 15, 7, 6, 5, 4, 3, 2, 1, 9, 17, 25, 33, 41,
                    49, 50, 51, 52, 53, 54, 46, 38, 30, 22, 14, 13, 12, 11, 10, 18, 26, 34, 42, 43, 44, 45, 37, 29, 21, 20, 19, 27, 35, 36, 28
                   };
  for (i = 64 - 1; i >= 0 ; i--) {
    matrix1.drawPixel(CWi2o[i], 0, aC[rndClr1]);
    matrix2.drawPixel(CWi2o[i], 0, aC[rndClr1]);
    matrix1.show();   matrix2.show(); delay(veryFast);
    matrix1.drawPixel(CWi2o[i], 0, BLACK);
    matrix2.drawPixel(CWi2o[i], 0, BLACK);
    matrix1.show();   matrix2.show();
  }
}
//------------------//
void boxCCWo2i() {                                      // Display all four boxes, Counter-ClockWise, outer-to-inner, on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(255);  matrix2.setBrightness(255);
  int CCWo2i[64] =  {0, 8, 16, 24, 32, 40, 48, 56, 57, 58, 59, 60, 61, 62, 63, 55, 47, 39, 31, 23, 15, 7, 6, 5, 4, 3, 2, 1, 9, 17, 25, 33, 41,
                     49, 50, 51, 52, 53, 54, 46, 38, 30, 22, 14, 13, 12, 11, 10, 18, 26, 34, 42, 43, 44, 45, 37, 29, 21, 20, 19, 27, 35, 36, 28
                    };
  for (i = 0; i < 64 ; i++) {
    matrix1.drawPixel(CCWo2i[i], 0, aC[rndClr1]);
    matrix2.drawPixel(CCWo2i[i], 0, aC[rndClr1]);
    matrix1.show();   matrix2.show(); delay(veryFast);
    matrix1.drawPixel(CCWo2i[i], 0, BLACK);
    matrix2.drawPixel(CCWo2i[i], 0, BLACK);
    matrix1.show();   matrix2.show();
  }
}
//------------------//
void boxCCWi2o() {                                      // Display all four boxes, counter-clockwise, inner-to-outer, on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(255);  matrix2.setBrightness(255);
  int CCWi2o[64] = { 0, 1, 2, 3, 4, 5, 6, 7, 15, 23, 31, 39, 47, 55, 63, 62, 61, 60, 59, 58, 57, 56, 48, 40, 32, 24, 16, 8, 9, 10, 11, 12, 13,
                     14, 22, 30, 38, 46, 54, 53, 52, 51, 50, 49, 41, 33, 25, 17, 18, 19, 20, 21, 29, 37, 45, 44, 43, 42, 34, 26, 27, 28, 36, 35
                   };
  for (i = 64 - 1; i >= 0; i--) {
    matrix1.drawPixel(CCWi2o[i], 0, aC[rndClr1]);
    matrix2.drawPixel(CCWi2o[i], 0, aC[rndClr1]);
    matrix1.show();   matrix2.show(); delay(veryFast);
    matrix1.drawPixel(CCWi2o[i], 0, BLACK);
    matrix2.drawPixel(CCWi2o[i], 0, BLACK);
    matrix1.show();   matrix2.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void boxesO2I2O() {         // D&E 4 boxes, starting with the outermost and working towards the innermost, then reverse direction.
  box1(); delay(veryFast);
  box2(); delay(veryFast);
  box3(); delay(veryFast);
  box4(); delay(veryFast);
  box3(); delay(veryFast);
  box2(); delay(veryFast);
  box1(); delay(veryFast);
}
//------------------//
void boxesI2O2I() {         // D&E 4 boxes, starting with the innermost and working towards the outermost, then reverse direction.
  box4(); delay(veryFast);
  box3(); delay(veryFast);
  box2(); delay(veryFast);
  box1(); delay(veryFast);
  box2(); delay(veryFast);
  box3(); delay(veryFast);
  box4(); delay(veryFast);
}
//------------------//
void box1() {
  //int rndClr1  = random(0, 24);
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int box1[28] = {0, 1, 2, 3, 4, 5, 6, 7, 15, 23, 31, 39, 47, 55, 63, 62, 61, 60, 59, 58, 57, 56, 48, 40, 32, 24, 16, 8};
  for (i = 0; i < 28; i++) {
    matrix1.drawPixel(box1[i], 0, BLUE);
    matrix2.drawPixel(box1[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
  delay(100);
  for (i = 0; i < 28; i++) {
    matrix1.drawPixel(box1[i], 0, BLACK);
    matrix2.drawPixel(box1[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void box2() {
  //int rndClr1  = random(0, 24);
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int box2[20] = {9, 10, 11, 12, 13, 14, 22, 30, 38, 46, 54, 53, 52, 51, 50, 49, 41, 33, 25, 17};
  for (i = 0; i < 20; i++) {
    matrix1.drawPixel(box2[i], 0, BLUE);
    matrix2.drawPixel(box2[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
  delay(100);
  for (i = 0; i < 20; i++) {
    matrix1.drawPixel(box2[i], 0, BLACK);
    matrix2.drawPixel(box2[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void box3() {
  //int rndClr1  = random(0, 24);
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int box3[12] = {18, 19, 20, 21, 29, 37, 45, 44, 43, 42, 34, 26};
  for (i = 0; i < 12; i++) {
    matrix1.drawPixel(box3[i], 0, BLUE);
    matrix2.drawPixel(box3[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
  delay(100);
  for (i = 0; i < 12; i++) {
    matrix1.drawPixel(box3[i], 0, BLACK);
    matrix2.drawPixel(box3[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void box4() {
  //int rndClr1  = random(0, 24);
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int box4[4] =  {27, 28, 35, 36};
  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(box4[i], 0, BLUE);
    matrix2.drawPixel(box4[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
  delay(100);
  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(box4[i], 0, BLACK);
    matrix2.drawPixel(box4[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void circleFill() {                                     // In both matrices, display each LED of a circle sequentially, then fill the circle.
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  matrix1.setBrightness(192);                           // 0-255. 127 = half-brightness. 192 = 3/4 brightness.
  matrix2.setBrightness(192);
  int circle[16] =  {11, 12, 10, 13, 17, 22, 25, 30, 33, 38, 41, 46, 50, 53, 51, 52};
  for (i = 0; i < 16; i++) {
    matrix1.drawPixel(circle[i], 0, aC[rndClr1]);
    matrix2.drawPixel(circle[i], 0, aC[rndClr2]);
    matrix1.show();   matrix2.show(); delay(fast);
  }
  delay(verySlow);
  for (i = 0; i < 16; i++) {
    matrix1.drawPixel(circle[i], 0, BLACK);
    matrix2.drawPixel(circle[i], 0, BLACK);
    matrix1.show();   matrix2.show();
  }
  matrix1.setBrightness(127);
  matrix2.setBrightness(127);
  int circleFill[32] =  {10, 11, 12, 13, 17, 18, 19, 20, 21, 22, 25, 26, 27, 28, 29, 30, 33, 34, 35, 36, 37, 38, 41, 42, 43, 44, 45, 46, 50, 51, 52, 53};
  for (i = 0; i < 32; i++) {
    matrix1.drawPixel(circleFill[i], 0, aC[rndClr1]);
    matrix2.drawPixel(circleFill[i], 0, aC[rndClr2]);
    matrix1.show();   matrix2.show();
  }
  delay(slow);
  blankMatrices();
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
/*  Each row of LEDs contains 8 LEDs. There are 8 rows of 8 LEDs.
    "i" creates a 4x4 block of LEDs that we can move around.
    "j" will move the "i" block of LEDs.
    If j is set to 8, then the i-block will advance downward one row at a time.
    32 / 8 = 4 rows. So j will advance the i-block downward a total of 4 times.
    If j is set to 32, the the i-block will advance downward once to the bottom half.
    If "k" is added with a value of 4, then the i-block will advance to the right by one i-block.
    The net effect is that the i-block will advance in this fashion:
    1 3
    2 4
    If you want to include the right matrix, then insert its actions separately before "j".
*/
void blockLRTBM12() {                       // Display and extinguish (D&E) each matrix's horizontal quadrant (4x4) of LEDs, L to R, T to B on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(64);   matrix2.setBrightness(64);
  int block[16] =  {0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27};
  for (k = 0; k <= 32; k = k + 32) {
    for (j = 0; j < 8; j = j + 4) {
      for (i = 0; i < 16; i++) {
        matrix1.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
        matrix2.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
        matrix1.show();   matrix2.show();  delay(5);
      }
      delay(150); blankMatrices();
    }
    //blankMatrices();
  }
}
//------------------//
void blockMarchLRTBM12() {                  // D&E a 4x4 block of LEDS advancing L to R, T to B on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(64); matrix2.setBrightness(64);
  int block[16] =  {0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27};
  for (j = 0; j < 5; j++) {
    for (i = 0; i < 16; i++) {
      matrix1.drawPixel(block[i] + j, 0, aC[rndClr1]);
      matrix2.drawPixel(block[i] + j, 0, aC[rndClr1]);
    }
    matrix1.show(); matrix2.show(); delay(slow);
    blankMatrices();
  }
  for (k = 32; k < 37; k++) {
    for (i = 0; i < 16; i++) {
      matrix1.drawPixel(block[i] + k, 0, aC[rndClr1]);
      matrix2.drawPixel(block[i] + k, 0, aC[rndClr1]);
    }
    matrix1.show(); matrix2.show(); delay(slow);
    blankMatrices();
  }
}
//------------------//
void blockLRM1M2() {              // D&E a 4x4 block of LEDS advancing across the left then the right matrix, then T to B.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(64); matrix2.setBrightness(64);
  int block[16] =  {0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27};

  for (j = 0; j < 8; j = j + 4) {   // Left matrix top, left block then right block.
    for (i = 0; i < 16; i++) {
      matrix1.drawPixel(block[i] + j + 0, 0, aC[rndClr1]);
    }
    matrix1.show(); delay(150);
    blankMatrix1();
  }
  for (M = 0; M < 8; M = M + 4) {   // Right matrix top, left block then right block.
    for (L = 0; L < 16; L++) {
      matrix2.drawPixel(block[L] + M + 0, 0, aC[rndClr1]);
    }
    matrix2.show(); delay(150);
    blankMatrix2();
  }

  for (j = 0; j < 8; j = j + 4) {   // Left matrix bottom, left block then right block.
    for (i = 0; i < 16; i++) {
      matrix1.drawPixel(block[i] + j + 32, 0, aC[rndClr1]);
    }
    matrix1.show(); delay(150);
    blankMatrix1();
  }
  for (M = 0; M < 8; M = M + 4) {   // Right matrix bottom, left block then right block.
    for (L = 0; L < 16; L++) {
      matrix2.drawPixel(block[L] + M + 32, 0, aC[rndClr1]);
    }
    matrix2.show(); delay(150);
    blankMatrix2();
  }
}
//------------------//
void blockTBLRM12() {                       // D&E a 4x4 block of LEDS, T to B and L to R, on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(64);   matrix2.setBrightness(64);
  int block[16] =  {0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27};
  for (k = 0; k < 8; k = k + 4) {
    for (j = 0; j < 64; j = j + 32) {
      for (i = 0; i < 16; i++) {
        matrix1.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
        matrix2.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
        matrix1.show();   matrix2.show();  delay(0);
      }
      delay(150); blankMatrices();
    }
  }
}
//------------------//
void blockMarchTBLRM12() {             // D&E a 4x4 block of LEDS advancing T to B and L to R on both matrices.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(64); matrix2.setBrightness(64);
  int block[16] =  {0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27};
  for (k = 0; k < 8; k = k + 4) {
    for (j = 0; j <= 32; j = j + 8) {
      for (i = 0; i < 16; i++) {
        matrix1.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
        matrix2.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
      }
      matrix1.show();   matrix2.show(); delay(150);
      blankMatrices();
    }
  }
}
//------------------//
void blockTBM1M2() {                   // D&E a 4x4 block of LEDS T to B and L to R on the left matrix then the right matrix.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(64); matrix2.setBrightness(64);
  int block[16] =  {0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27};

  for (k = 0; k < 8; k = k + 4) {
    for (j = 0; j < 64; j = j + 32) {   // Left matrix top, left block then right block.
      for (i = 0; i < 16; i++) {
        matrix1.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
      }
      matrix1.show(); delay(150);
      blankMatrix1();
    }
  }

  for (k = 0; k < 8; k = k + 4) {
    for (j = 0; j < 64; j = j + 32) {   // Left matrix top, left block then right block.
      for (i = 0; i < 16; i++) {
        matrix2.drawPixel(block[i] + j + k, 0, aC[rndClr1]);
      }
      matrix2.show(); delay(150);
      blankMatrix2();
    }
  }
}
//------------------//
void rowWaveT2B2T() {             // D&E a row of LEDS as a wave from Top to Bottom to Top.
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(127); matrix2.setBrightness(127);
  int row[8] =  {0, 1, 2, 3, 4, 5, 6, 7};

  for (j = 0; j < 63; j = j + 8) {
    for (i = 0; i < 8; i++) {
      matrix1.drawPixel(row[i] + j + 0, 0, aC[rndClr1]);
      matrix2.drawPixel(row[i] + j + 0, 0, aC[rndClr1]);
    }
    matrix1.show();   matrix2.show(); delay(fast);
    blankMatrices();
  }
  for (j = 56; j >= 0; j = j - 8) {
    for (i = 0; i < 8; i++) {
      matrix1.drawPixel(row[i] + j, 0, aC[rndClr1]);
      matrix2.drawPixel(row[i] + j, 0, aC[rndClr1]);
    }
    matrix1.show();   matrix2.show(); delay(fast);
    blankMatrices();
  }
}
//------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------//
void boxes4O2I2O() {                    // 4 boxes, Outer to Inner to Outer
  int rndClr1  = random(0, 24);
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int box1[4] =  {27, 28, 35, 36};
  int box2[12] = {18, 19, 20, 21, 29, 37, 45, 44, 43, 42, 34, 26};
  int box3[20] = {9, 10, 11, 12, 13, 14, 22, 30, 38, 46, 54, 53, 52, 51, 50, 49, 41, 33, 25, 17};
  int box4[28] = {0, 1, 2, 3, 4, 5, 6, 7, 15, 23, 31, 39, 47, 55, 63, 62, 61, 60, 59, 58, 57, 56, 48, 40, 32, 24, 16, 8};

  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(box1[i], 0, aC[rndClr1]);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(box1[i], 0, BLACK);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 12; i++) {
    matrix1.drawPixel(box2[i], 0, aC[rndClr1]);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 12; i++) {
    matrix1.drawPixel(box2[i], 0, BLACK);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 20; i++) {
    matrix1.drawPixel(box3[i], 0, aC[rndClr1]);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 20; i++) {
    matrix1.drawPixel(box3[i], 0, BLACK);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 28; i++) {
    matrix1.drawPixel(box4[i], 0, aC[rndClr1]);
    matrix1.show();
  }
  delay(normal);
  for (i = 0; i < 28; i++) {
    matrix1.drawPixel(box4[i], 0, BLACK);
    matrix1.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void diamonds6() {            // Sequentially display 6 diamond shapes, blank all, D&E all 6.
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  dimnd2(); delay(normal);
  dimnd5(); delay(normal);
  dimnd18(); delay(normal);
  dimnd21(); delay(normal);
  dimnd34(); delay(normal);
  dimnd37(); delay(verySlow);
  dimnd2Blank();
  dimnd5Blank();
  dimnd18Blank();
  dimnd21Blank();
  dimnd34Blank();
  dimnd37Blank();
  delay(slow);

  dimnd2();
  dimnd5();
  dimnd18();
  dimnd21();
  dimnd34();
  dimnd37();
  delay(verySlow);
  dimnd2Blank();
  dimnd5Blank();
  dimnd18Blank();
  dimnd21Blank();
  dimnd34Blank();
  dimnd37Blank();
}
//------------------//
void dimnd2() {
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int dimnd2[5] = {2, 9, 10, 11, 18};
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd2[i], 0, BLUE);
    matrix2.drawPixel(dimnd2[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
}
void dimnd2Blank() {
  int dimnd2[5] = {2, 9, 10, 11, 18};
  //delay(normal);
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd2[i], 0, BLACK);
    matrix2.drawPixel(dimnd2[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void dimnd5() {
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int dimnd5[5] = {5, 12, 13, 14, 21};
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd5[i], 0, BLUE);
    matrix2.drawPixel(dimnd5[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
}
void dimnd5Blank() {
  int dimnd5[5] = {5, 12, 13, 14, 21};
  //delay(normal);
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd5[i], 0, BLACK);
    matrix2.drawPixel(dimnd5[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void dimnd18() {
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int dimnd18[5] = {18, 25, 26, 27, 34};
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd18[i], 0, BLUE);
    matrix2.drawPixel(dimnd18[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
}
void dimnd18Blank() {
  int dimnd18[5] = {18, 25, 26, 27, 34};
  //delay(normal);
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd18[i], 0, BLACK);
    matrix2.drawPixel(dimnd18[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void dimnd21() {
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int dimnd21[5] = {21, 28, 29, 30, 37};
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd21[i], 0, BLUE);
    matrix2.drawPixel(dimnd21[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
}
void dimnd21Blank() {
  int dimnd21[5] = {21, 28, 29, 30, 37};
  //delay(normal);
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd21[i], 0, BLACK);
    matrix2.drawPixel(dimnd21[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void dimnd34() {
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int dimnd34[5] = {34, 41, 42, 43, 50};
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd34[i], 0, BLUE);
    matrix2.drawPixel(dimnd34[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
}
void dimnd34Blank() {
  int dimnd34[5] = {34, 41, 42, 43, 50};
  //delay(normal);
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd34[i], 0, BLACK);
    matrix2.drawPixel(dimnd34[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------//
void dimnd37() {
  matrix1.setBrightness(127);  matrix2.setBrightness(127);
  int dimnd37[5] = {37, 44, 45, 46, 53};
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd37[i], 0, BLUE);
    matrix2.drawPixel(dimnd37[i], 0, BLUE);
    matrix1.show(); matrix2.show();
  }
}
void dimnd37Blank() {
  int dimnd37[5] = {37, 44, 45, 46, 53};
  //delay(normal);
  for (i = 0; i < 5; i++) {
    matrix1.drawPixel(dimnd37[i], 0, BLACK);
    matrix2.drawPixel(dimnd37[i], 0, BLACK);
    matrix1.show(); matrix2.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void tictactoe() {            // D&E tictactoe board on M12, then TL2BR objects on M1, then BL2TR objects on M2.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int tictactoe[28] = {2, 5, 10, 13, 16, 17, 18, 19, 20, 21, 22, 23, 26, 29,
                       34, 37, 40, 41, 42, 43, 44, 45, 46, 47, 50, 53, 58, 61
                      };
  int tic0[4] = {0, 1, 8, 9};
  int tic27[4] = {27, 28, 35, 36};
  int tic54[4] = {54, 55, 62, 63};
  int tic48[4] = {48, 49, 56, 57};
  int tic6[4] = {6, 7, 14, 15};
  for (i = 0; i < 28; i++) {
    matrix1.drawPixel(tictactoe[i], 0, WHITE);
    matrix2.drawPixel(tictactoe[i], 0, WHITE);
    matrix1.show(); matrix2.show();
  }
  delay(verySlow);
  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(tic0[i], 0, RED);
    matrix1.show();
  }
  delay(verySlow);
  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(tic27[i], 0, RED);
    matrix1.show();
  }
  delay(verySlow);
  for (i = 0; i < 4; i++) {
    matrix1.drawPixel(tic54[i], 0, RED);
    matrix1.show();
  }
  //////////
  delay(verySlow);
  for (i = 0; i < 4; i++) {
    matrix2.drawPixel(tic48[i], 0, BLUE);
    matrix2.show();
  }
  delay(verySlow);
  for (i = 0; i < 4; i++) {
    matrix2.drawPixel(tic27[i], 0, BLUE);
    matrix2.show();
  }
  delay(verySlow);
  for (i = 0; i < 4; i++) {
    matrix2.drawPixel(tic6[i], 0, BLUE);
    matrix2.show();
  }
  delay(verySlow);
  blankMatrices();
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void gridSpots() {                          // Draw a grid then D&E spots within the grid.
  matrix1.setBrightness(32);  matrix2.setBrightness(32);
  int spots[16] = {8, 10, 12, 14, 24, 26, 28, 30, 40, 42, 44, 46, 56, 58, 60, 62};
  for (i = 1; i < 64; i = i + 2) {          // Draw vertical grid.
    matrix1.drawPixel(i, 0, WHITE);
    matrix2.drawPixel(i, 0, WHITE);
    matrix1.show();  matrix2.show();
    delay(10);
  }
  for (j = 0; j < 64; j = j + 16) {         // Draw horizontal grid.
    for (i = 0; i < 8; i++) {
      matrix1.drawPixel(i + j, 0, WHITE);
      matrix2.drawPixel(i + j, 0, WHITE);
      matrix1.show();  matrix2.show();
      delay(25);
    }
  }
  for (j = 0; j < 24 ; j++) {               // D&E objects within the grid.
    int rndClr1  = random(0, 24);
    for (i = 0; i < 16; i++) {
      matrix1.setBrightness(64);
      matrix1.drawPixel(spots[i] , 0, aC[rndClr1]);
      matrix2.drawPixel(spots[i] , 0, aC[rndClr1]);
      matrix1.show();  matrix2.show();
      delay(25);
    }
  }
  delay(verySlow);
  blankMatrices();
}
//------------------//
















void xCross() {}                     // Form the shape of a cross in each matrix.

//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
